<template>
  <dashboard-layout title="Accueil" class="backG">

    <div class="card col-6 mx-auto" style="margin-top: 100px;">
      <slot name="header">
        <strong class="mx-auto mt-5"><h4>Faire une review</h4></strong>
      </slot>
      <div class="m-5" v-if="isLoading">
        <fulfilling-bouncing-circle-spinner class="mx-auto" :animation-duration="2000"
          :size="60" :color="'#005C96'"  />
      </div>
      <div v-else>
        <div class="alert alert-danger" v-if="errorMessage">{{ errorMessage }}</div>
        <form @submit="reviewSubmit" class="col-10 mx-auto" >
          <div class="form-group mx-auto" >
            <label class="">Résumé</label>
            <textarea class="form-control" rows="6" v-model="editReviewing.summary" required></textarea>
          </div>
          <div class="form-group mx-auto" >
            <label class="">Commentaire</label>
            <textarea class="form-control" rows="6" v-model="editReviewing.comment" required ></textarea>
          </div>
          <div class="form-group mx-auto" >
            <label class="">Note</label>
            <v-select class="form-control-select" v-model="editReviewing.mark"  required
              :options="[{label: 'Acceptable', code: 'acceptable'}, {label: 'Bien', code: 'bien'},
                        {label: 'Très Bien', code: 'tresbien'} ]"></v-select>
          </div>
          <div class="modal-footer col-4 mx-auto"> <button type="submit" class="btn btn-light btn-block">Enregistrer</button></div>
        </form>
      </div> 
    </div>
   
  </dashboard-layout>
</template>


<script> 
export default {
  name: "accueil",
  components: {},
  data() {
    return {
      errorMessage: "",
      currentSubmissionId: 0,
      isLoading: false,
      reviewerId: "",
      currentReviewing: null,
      editReviewing: {
        mark: "",
        summary: "",
        comment: "",
      },

      searchtext: "",
      searchtype: "",
      curPage: 1,
      perPage: 100,

      // user: {},
      // agenceLog: false,
      // load: false,
    };
  },
  mounted() {
    this.currentSubmissionId = this.$route.params.id;
    this.reviewerId = localStorage.getItem("adminId");
    this.getReview();
  },
  methods: { 

    reviewSubmit(e){
      e.preventDefault();
      console.log('datas: ', this.editReviewing)
      this.isLoading = true;

      if(this.currentReviewing.reviewers){
        this.currentReviewing.reviewers.forEach((value, index) => {
          //this.currentReviewing.reviewers[index].reviewer
          console.log("--------------------- ", value )
          if(value.reviewer == this.reviewerId ){
            console.log("--------------------- found",  )  
            let object = {
              reviewer : value.reviewer,
              mark:   this.editReviewing.mark.code,
              summary: this.editReviewing.summary,
              comment: this.editReviewing.comment,
            }
            console.log("--------------------- object ", object  )  
            this.currentReviewing.reviewers[index] = object;
            return;
          }
        });

        console.log("-------- currentReviewing: ",this.currentReviewing , this.currentReviewing.reviewers );

        this.$service.update("reviews",this.currentReviewing._id, { 'reviewers': this.currentReviewing.reviewers },"make review",(err, data) => {
          if (err) {
            this.errorMessage = err.data && err.data.message;
            return;
          }
          // console.log("add reviewer data: ", data);
          this.isLoading = false;
          if(data){
            this.$swal.fire("Modification effectuée !", "", "success").then(() => {
              this.$router.push({ path: "/detailsubmission/" + this.currentSubmissionId });
            });
          }
        });
      } 
    },
    getReview(){
      this.isLoading = true
      let query = {
        options: { submission: this.currentId, },
        filter: {
          text: this.searchtext,
          type: this.searchtype.split("+"),
        },
        sort: {},
        page: this.curPage - 1,
        perPage: this.perPage,
      };
      this.$service.list("reviews", query, (err, data) => {
        if (err) { this.isLoading = false; this.errorMessage = err.data && err.data.message; return; }
        if (data.reviews[0]) {
          this.currentReviewing = data.reviews[0];
          // console.log("-------- currentReviewing: ",this.currentReviewing );
          this.isLoading = false; 
        }else{
          // console.log('no reviews for the submisison',this.currentReviewing );
          this.isLoading = false;
        }
      }); 
    }
  },
};
</script>





<style lang="scss" scoped>

</style>

